commit:     402c1a598514f09c6980507d8b9f91f75994c98e
Author:     Arthur Zamarin <arthurzam <AT> gentoo <DOT> org>
AuthorDate: Tue Feb 24 16:51:46 2026 +0000
Commit:     Arthur Zamarin <arthurzam <AT> gentoo <DOT> org>
CommitDate: Tue Feb 24 17:03:15 2026 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=402c1a59

app-arch/7zip: add 26.00

Signed-off-by: Arthur Zamarin <arthurzam <AT> gentoo.org>

 app-arch/7zip/7zip-26.00.ebuild | 118 ++++++++++++++++++++++++++++++++++++++++
 app-arch/7zip/Manifest          |   2 +
 2 files changed, 120 insertions(+)

diff --git a/app-arch/7zip/7zip-26.00.ebuild b/app-arch/7zip/7zip-26.00.ebuild
new file mode 100644
index 000000000000..03e5739bc5b4
--- /dev/null
+++ b/app-arch/7zip/7zip-26.00.ebuild
@@ -0,0 +1,118 @@
+# Copyright 2023-2026 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+inherit edos2unix flag-o-matic toolchain-funcs
+
+NO_DOT_PV=$(ver_rs 1- '')
+DESCRIPTION="Free file archiver for extremely high compression"
+HOMEPAGE="https://www.7-zip.org/ https://sourceforge.net/projects/sevenzip/";
+# linux-x64 tarball is only used for docs
+SRC_URI="
+       
https://downloads.sourceforge.net/sevenzip/7-Zip/${PV}/7z${NO_DOT_PV}-src.tar.xz
+       
https://downloads.sourceforge.net/sevenzip/7-Zip/${PV}/7z${NO_DOT_PV}-linux-x64.tar.xz
+"
+S="${WORKDIR}"
+
+LICENSE="LGPL-2 BSD rar? ( unRAR )"
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~loong ~ppc ~ppc64 ~riscv ~s390 
~sparc ~x86"
+IUSE="uasm jwasm rar +symlink"
+REQUIRED_USE="?? ( uasm jwasm )"
+
+DOCS=( readme.txt History.txt License.txt )
+HTML_DOCS=( MANUAL )
+
+BDEPEND="
+       app-arch/xz-utils[extra-filters(+)]
+       uasm? ( dev-lang/uasm )
+       jwasm? ( dev-lang/jwasm )
+"
+RDEPEND="
+       symlink? ( !app-arch/p7zip )
+"
+
+PATCHES=(
+       "${FILESDIR}/${PN}-24.05-respect-build-env.patch"
+)
+
+# TODO(NRK): also build and install the library
+# TODO(NRK): make it so this package can be used as a drop-in replacement
+# for app-arch/p7zip ??
+
+pkg_setup() {
+       # instructions in DOC/readme.txt, Compiling 7-Zip for Unix/Linux
+       # TLDR; every combination of options (clang|gcc)+(asm/noasm)
+       # has a dedicated makefile & builddir
+       mfile="cmpl"
+       if tc-is-clang; then
+               mfile="${mfile}_clang"
+               bdir=c
+       elif tc-is-gcc; then
+               mfile="${mfile}_gcc"
+               bdir=g
+       else
+               die "Unsupported compiler: $(tc-getCC)"
+       fi
+       if use jwasm || use uasm ; then
+               mfile="${mfile}_x64"
+               bdir="${bdir}_x64"
+       fi
+       export mfile="${mfile}.mak"
+       export bdir
+}
+
+src_prepare() {
+       # patch doesn't deal with CRLF even if file+patch match
+       # not even with --ignore-whitespace, --binary or --force
+       pushd "./CPP/7zip" || die "Unable to switch directory"
+       edos2unix ./7zip_gcc.mak ./var_gcc{,_x64}.mak ./var_clang{,_x64}.mak
+       sed -i -e 's/-Werror //g' ./7zip_gcc.mak || die "Error removing -Werror"
+       popd >/dev/null || die "Unable to switch directory"
+
+       default
+}
+
+src_compile() {
+       pushd "./CPP/7zip/Bundles/Alone2" || die "Unable to switch directory"
+
+       # avoid executable stack when using uasm/jwasm, harmless otherwise
+       append-ldflags -Wl,-z,noexecstack
+       export G_CFLAGS=${CFLAGS}
+       export G_CXXFLAGS=${CXXFLAGS}
+       export G_LDFLAGS=${LDFLAGS}
+
+       local args=(
+               -f "../../${mfile}"
+               CC=$(tc-getCC)
+               CXX=$(tc-getCXX)
+       )
+       # NOTE: makefile doesn't check the value of DISABLE_RAR_COMPRESS, only
+       # whether it's defined or not. so in case user has `rar` enabled
+       # DISABLE_RAR_COMPRESS (and DISABLE_RAR) needs to stay undefined.
+       if ! use rar; then
+               # disables non-free rar code but allows listing and extracting
+               # non-compressed rar archives
+               args+=( DISABLE_RAR_COMPRESS=1 )
+       fi
+       if use jwasm; then
+               args+=( USE_JWASM=1 )
+       elif use uasm; then
+               args+=( MY_ASM=uasm )
+       fi
+
+       mkdir -p "${bdir}" || die  # Bug: https://bugs.gentoo.org/933619
+       emake ${args[@]}
+       popd > /dev/null || die "Unable to switch directory"
+}
+
+src_install() {
+       dobin "./CPP/7zip/Bundles/Alone2/b/${bdir}/7zz"
+       if use symlink; then
+               dosym 7zz /usr/bin/7z
+               dosym 7zz /usr/bin/7za
+               dosym 7zz /usr/bin/7zr
+       fi
+       einstalldocs
+}

diff --git a/app-arch/7zip/Manifest b/app-arch/7zip/Manifest
index 34f8e0217e09..b169e498e2fa 100644
--- a/app-arch/7zip/Manifest
+++ b/app-arch/7zip/Manifest
@@ -1,2 +1,4 @@
 DIST 7z2501-linux-x64.tar.xz 1571044 BLAKE2B 
ec260b50da5781ad547cbb506bc8ab51250acdfa63ca0b03ad43c4ae475ea181f4b102959cf4470943e43d910f97eb29c387af3512b80ecbcf43535d99f22e09
 SHA512 
3f80196dd053456993e5f6585768b863b8c06a77e3c14c61b818ef8cedfbf07c162e95d76b26ecc1926951c56ee54db8f5b6842e52f84d4b4db5bcbfaf9f1319
 DIST 7z2501-src.tar.xz 1533240 BLAKE2B 
4625869325d2f73553a79c5da59b0c5924a6e744a23d62d108edeeb15c164c812b38c25d386dab73917be1be0daf2701c60adf6fcdffe853ea946525915bbcf7
 SHA512 
5ee146ce993c6d12ad19333dc3545e6c3429212260c22d456390e49ca150e6fcbfc6eae45b5ec61138ae1598d7b4a79d6f2e3ff02929af38039c0ca59823e729
+DIST 7z2600-linux-x64.tar.xz 1572504 BLAKE2B 
5d60d86dbdbe4fa0bfb5029e7c5edef4656a114c5a6e55bc05592cb0b7778348e90456e3b90184900185af3de8d65cc481db4c4c83f761f7e1cb0c5df6f6958b
 SHA512 
b106ff9d6c15eecffba1d0117e7f23fcdecb80e8b15f7d06cf114ae7d489908806f477517ec2f7568c2dd6056471088d3cbde0ddfe37d668af81645da9074252
+DIST 7z2600-src.tar.xz 1538112 BLAKE2B 
4ac1ecf98aa3bdcc968a75e250b467b0c38eb27dd6752fdc7c025d6d1b73cca648a12ba8a26691443cf929c22ef560c211959693f82acdff5d27cf0f8d159645
 SHA512 
2374b3d90388838391ef35a95a81e97639478598011d46adee9ddb84ed8c287fad47f6d2d794c22b0fc5c1f7dec4bfaaa25b6e747c5e78100eb63818fe85b897

Reply via email to